<div class="container" *ngIf="reservas.length > 0 || productos.length > 0 else mensaje">
  <h1 class="titulo">Ventas finalizadas</h1>
  <p-dataView #dv [value]="productos" [layout]="'grid'" [paginator]="true" [rows]="6"
    emptyMessage="No hay ventas finalizadas para calificar">

    <ng-template let-productos pTemplate="gridItem">
      <div class="grid grid-nogutter">
        <div class="col-12 sm:col-6 lg:col-12 xl:col-4 p-2 flex justify-content-center"
          *ngFor="let producto of productos">
          <div class="p-4 border-1 surface-border surface-card border-round w-20rem">
            <div class="flex flex-wrap align-items-center justify-content-between gap-2">
              <span class="flex align-items-center gap-2">
                <i class="pi pi-tag"></i>
                <span class="font-semibold">{{ producto.Categoria }}</span>
              </span>
              <p-tag>Cantidad: {{ producto.Cantidad }}</p-tag>
            </div>
            <div class="flex flex-column align-items-center gap-3 py-5">
              <figure class="w-9 h-9rem shadow-2 border-round img-productoGrid">
                <p-image [src]="producto.ImgUrl" [alt]="producto.Nombre" [preview]="true"></p-image>
              </figure>
              <div class="flex flex-column gap-1 align-items-center">
                <div class="text-2xl font-bold">{{ producto.Nombre }}</div>
                <span class="text-lg font-medium">
                  <a class="link_style" (click)="verEmprendimiento(producto.idEmpresa)">{{ producto.Empresa }}</a>
                </span>
              </div>
              <div class="calificar">
                <button pButton label="Calificar" (click)="abrirDialogCalificacion(producto)"
                  class="calificar-btn"></button>
              </div>
            </div>
            <div class="flex align-items-center justify-content-between">
              <span class="text-lg font-semibold">Precio: {{ 'Bs' + producto.PrecioVenta }}</span>
              <span class="text-lg font-semibold">Total: {{ 'Bs' + producto.PrecioVenta * producto.Cantidad }}</span>
            </div>
          </div>
        </div>
      </div>
    </ng-template>
  </p-dataView>

  <h1 class="titulo">Reservas finalizadas</h1>
  <p-dataView #dv [value]="reservas" [layout]="'grid'" [paginator]="true" [rows]="6"
    emptyMessage="No hay reservas finalizadas para calificar">

    <ng-template let-reservas pTemplate="gridItem">
      <div class="grid grid-nogutter">
        <div class="col-12 sm:col-6 lg:col-12 xl:col-4 p-2 flex justify-content-center"
          *ngFor="let reserva of reservas">
          <div class="p-4 border-1 surface-border surface-card border-round w-20rem">
            <div class="flex flex-wrap align-items-center justify-content-between gap-2">
              <span class="flex align-items-center gap-2">
                <i class="pi pi-tag"></i>
                <span class="font-semibold">{{ reserva.Categoria }}</span>
              </span>
              <p-tag>Cantidad: {{ reserva.Cantidad }}</p-tag>
            </div>
            <div class="flex flex-column align-items-center gap-3 py-5">
              <figure class="w-9 h-9rem shadow-2 border-round img-productoGrid">
                <p-image [src]="reserva.ImgUrl" [alt]="reserva.Nombre" [preview]="true"></p-image>
              </figure>
              <div class="flex flex-column gap-1 align-items-center">
                <div class="text-2xl font-bold">{{ reserva.Nombre }}</div>
                <span class="text-lg font-medium">
                  <a class="link_style" (click)="verEmprendimiento(reserva.idEmpresa)">{{ reserva.Empresa }}</a>
                </span>
              </div>
              <div class="calificar">
                <button pButton label="Calificar" (click)="abrirDialogCalificacion(reserva)"
                  class="calificar-btn"></button>
              </div>
            </div>
            <div class="flex align-items-center justify-content-between">
              <span class="text-lg font-semibold">Precio: {{ 'Bs' + reserva.PrecioVenta }}</span>
              <span class="text-lg font-semibold">Total: {{ 'Bs' + reserva.PrecioVenta * reserva.Cantidad }}</span>
            </div>
          </div>
        </div>
      </div>
    </ng-template>
  </p-dataView>
</div>

<ng-template #mensaje>
  <div class="flex flex-column align-items-center gap-4 h-full pt-6">
    <div class="text-2xl font-semibold uppercase">No tienes productos comprados</div>
    <button pButton type="button" label="Ir a comprar" routerLink="../listaproductos" class="btn"></button>
  </div>
</ng-template>

<div class="dialog-container-general">
  <p-dialog header="Calificación" [(visible)]="dialogCalificacion" [style]="{width: '40vw'}" [modal]="true"
    class="modal-container">
    <div class="detalleCalificacion">
      <div class="fila">
        <span><label>Codigo de {{producto.idDetalleReserva ? 'reserva' : 'compra'}}</label>{{ producto.Codigo }}</span>
        <span><label>Emprendimiento</label>{{ producto.Empresa }}</span>
      </div>

      <div class="fila">
        <span><label>Producto</label>{{ producto.Nombre }}</span>
        <span><label>Cantidad</label>{{ producto.Cantidad }}</span>
      </div>

      <div class="fila">
        <span><label>Total(Bs)</label>{{ producto.Total }}</span>
      </div>

      <div class="fila">
        <span><label>Fecha de compra</label>{{ obtenerFecha(producto.FechaCompra) }}</span>
      </div>

      <div class="calificacion">
        <label>Calificación</label>
        <p-rating [(ngModel)]="calificacion" [cancel]="false" [disabled]="false"></p-rating>
        <textarea rows="5" cols="30" pInputTextarea [(ngModel)]="comentario"
          placeholder="Comentario (Opcional)"></textarea>
      </div>
    </div>

    <ng-template pTemplate="footer">
      <div class="flex gap-3 justify-content-center">
        <button pButton type="button" label="Calificar" (click)="calificarVenta(producto)" class="btn"></button>
      </div>
    </ng-template>
  </p-dialog>
</div>

<app-loading-overlay *ngIf="mostrarSpinner" [mensaje]="'Calificando emprendimiento...'"></app-loading-overlay>
